# cloudfront_origin_access_identity – create, update and delete origin access identities for a cloudfront distribution

New in version 2.5.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Allows for easy creation, updating and deletion of origin access identities.

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3 >= 1.0.0
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
caller_reference - |  | A unique identifier to reference the origin access identity by.
comment - |  | A comment to describe the cloudfront origin access identity.

debug_botocore_endpoint_logs
boolean
added in 2.8

Choices:
- no ←
- yes

Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.

ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
origin_access_identity_id - |  | The origin_access_identity_id of the cloudfront distribution.
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token

state
-

Choices:
- present
- absent

Default:
"update_origin_access_identity"

If the named resource should exist.

validate_certs
boolean

Choices:
- no
- yes ←

When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- does not support check mode
- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: create an origin access identity
      cloudfront_origin_access_identity:
        state: present
        caller_reference: this is an example reference
        comment: this is an example comment

    - name: update an existing origin access identity using caller_reference as an identifier
      cloudfront_origin_access_identity:
         origin_access_identity_id: E17DRN9XUOAHZX
         caller_reference: this is an example reference
         comment: this is a new comment

    - name: delete an existing origin access identity using caller_reference as an identifier
      cloudfront_origin_access_identity:
         state: absent
         caller_reference: this is an example reference
         comment: this is a new comment

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
cloud_front_origin_access_identity complex | always | The origin access identity's information.
| cloud_front_origin_access_identity_config complex | always | describes a url specifying the origin access identity.
|  | caller_reference string | always | a caller reference for the oai
|  | comment string | always | a comment describing the oai
| id string | always | a unique identifier of the oai
| s3_canonical_user_id string | always | the canonical user id of the user who created the oai
e_tag string | always | The current version of the origin access identity created.
location string | when initially created | The fully qualified URI of the new origin access identity just created.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Willem van Ketwich (@wilvk)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.